###Compare L1 utility with Lap, TLap, MR, GDP and TGDP###
set.seed(1)
##Optimal mechanism
n=500
p=rep(1/(n+1), n+1)
size=5000
eps=0.25
opt_dat25=cbind(generate_optimal_data(n, eps, p, size, obs=5),
                generate_optimal_data(n, eps, p, size, obs=200),
                generate_optimal_data(n, eps, p, size, obs=450))
eps=0.5
opt_dat5=cbind(generate_optimal_data(n, eps, p, size, obs=5),
               generate_optimal_data(n, eps, p, size, obs=200),
               generate_optimal_data(n, eps, p, size, obs=450))
eps=0.75
opt_dat75=cbind(generate_optimal_data(n, eps, p, size, obs=5),
                generate_optimal_data(n, eps, p, size, obs=200),
                generate_optimal_data(n, eps, p, size, obs=450))

##Lap mechanism
n=500
eps=0.25
lap_dat25=cbind(generate_laplace_nom(eps, x=5, size, n),
                generate_laplace_nom(eps, x=200, size, n),
                generate_laplace_nom(eps, x=450, size, n))
eps=0.5
lap_dat5=cbind(generate_laplace_nom(eps, x=5, size, n),
               generate_laplace_nom(eps, x=200, size, n),
               generate_laplace_nom(eps, x=450, size, n))
eps=0.75
lap_dat75=cbind(generate_laplace_nom(eps, x=5, size, n),
                generate_laplace_nom(eps, x=200, size, n),
                generate_laplace_nom(eps, x=450, size, n))

##MR mechanism
eps=0.25
mc_dat25=cbind(generate_mc(eps, n, x=5, size),
               generate_mc(eps, n, x=200, size),
               generate_mc(eps, n, x=450, size))
eps=0.5
mc_dat5=cbind(generate_mc(eps, n, x=5, size),
              generate_mc(eps, n, x=200, size),
              generate_mc(eps, n, x=450, size))
eps=0.75
mc_dat75=cbind(generate_mc(eps, n, x=5, size),
               generate_mc(eps, n, x=200, size),
               generate_mc(eps, n, x=450, size))


##GDP mechanism
n=500
eps=0.25
size=500
delta=1/n
GDP_dat25=cbind(generate_GDP(eps, delta, x=5, size, n),
                generate_GDP(eps, delta, x=200, size, n),
                generate_GDP(eps, delta, x=450, size, n))
eps=0.5
GDP_dat5=cbind(generate_GDP(eps, delta, x=5, size, n),
               generate_GDP(eps, delta, x=200, size, n),
               generate_GDP(eps, delta, x=450, size, n))
eps=0.75
GDP_dat75=cbind(generate_GDP(eps, delta, x=5, size, n),
                generate_GDP(eps, delta, x=200, size, n),
                generate_GDP(eps, delta, x=450, size, n))


#TLap mechanism
n=500
eps=0.25
lap_dat25_trunc=cbind(generate_laplace_nom_trunc(eps, x=5, size, n),
                      generate_laplace_nom_trunc(eps, x=200, size, n),
                      generate_laplace_nom_trunc(eps, x=450, size, n))
eps=0.5
lap_dat5_trunc=cbind(generate_laplace_nom_trunc(eps, x=5, size, n),
                     generate_laplace_nom_trunc(eps, x=200, size, n),
                     generate_laplace_nom_trunc(eps, x=450, size, n))
eps=0.75
lap_dat75_trunc=cbind(generate_laplace_nom_trunc(eps, x=5, size, n),
                      generate_laplace_nom_trunc(eps, x=200, size, n),
                      generate_laplace_nom_trunc(eps, x=450, size, n))

#TGDP mechanism
n=500
eps=0.25
delta=1/n
GDP_dat25_trunc=cbind(generate_GDP_trunc(eps, delta, x=5, size, n),
                      generate_GDP_trunc(eps, delta, x=200, size, n),
                      generate_GDP_trunc(eps, delta, x=450, size, n))
eps=0.5
GDP_dat5_trunc=cbind(generate_GDP_trunc(eps, delta, x=5, size, n),
                     generate_GDP_trunc(eps, delta, x=200, size, n),
                     generate_GDP_trunc(eps, delta, x=450, size, n))
eps=0.75
GDP_dat75_trunc=cbind(generate_GDP_trunc(eps, delta, x=5, size, n),
                      generate_GDP_trunc(eps, delta, x=200, size, n),
                      generate_GDP_trunc(eps, delta, x=450, size, n))


#L1 loss
dat=c(5, 200, 450)
opt_l1_l25=compute_L1_loss(opt_dat25, dat)
opt_l1_l5=compute_L1_loss(opt_dat5, dat) 
opt_l1_l75=compute_L1_loss(opt_dat75, dat)

lap_l1_l25=compute_L1_loss(lap_dat25, dat)
lap_l1_l5=compute_L1_loss(lap_dat5, dat)
lap_l1_l75=compute_L1_loss(lap_dat75, dat)

lap_l1_l25_trunc=compute_L1_loss(lap_dat25_trunc, dat)
lap_l1_l5_trunc=compute_L1_loss(lap_dat5_trunc, dat)
lap_l1_l75_trunc=compute_L1_loss(lap_dat75_trunc, dat)

GDP_l1_l25=compute_L1_loss(GDP_dat25, dat)
GDP_l1_l5=compute_L1_loss(GDP_dat5, dat)
GDP_l1_l75=compute_L1_loss(GDP_dat75, dat)

GDP_l1_l25_trunc=compute_L1_loss(GDP_dat25_trunc, dat)
GDP_l1_l5_trunc=compute_L1_loss(GDP_dat5_trunc, dat)
GDP_l1_l75_trunc=compute_L1_loss(GDP_dat75_trunc, dat)

mc_l1_l25=compute_L1_loss(mc_dat25, dat)
mc_l1_l5=compute_L1_loss(mc_dat5, dat)
mc_l1_l75=compute_L1_loss(mc_dat75, dat)


#Evaluate proportion negative
prop_neg_lap25=prop_negative(lap_dat25)#0.1226
prop_neg_lap5=prop_negative(lap_dat5)#0.0368
prop_neg_lap75=prop_negative(lap_dat75)#0.009
prop_neg_opt25=prop_negative(opt_dat25)#0
prop_neg_opt5=prop_negative(opt_dat5)#0
prop_neg_opt75=prop_negative(opt_dat75)#0
prop_neg_GDP25=prop_negative(GDP_dat25)#0.368
prop_neg_GDP5=prop_negative(GDP_dat5)#0.21
prop_neg_GDP75=prop_negative(GDP_dat75)#0.104





##Plot all the L1 losses using box-plots
eps25_x5=cbind(mc_l1_l25[,1], GDP_l1_l25[,1], GDP_l1_l25_trunc[,1], lap_l1_l25[,1], lap_l1_l25_trunc[,1], opt_l1_l25[,1])
eps25_x250=cbind(mc_l1_l25[,2], GDP_l1_l25[,2], GDP_l1_l25_trunc[,2], lap_l1_l25[,2], lap_l1_l25_trunc[,2], opt_l1_l25[,2])
eps25_x450=cbind(mc_l1_l25[,3], GDP_l1_l25[,3], GDP_l1_l25_trunc[,3], lap_l1_l25[,3], lap_l1_l25_trunc[,3], opt_l1_l25[,3])
r1=round(rbind(apply(eps25_x5, 2, mean),
               apply(eps25_x5, 2, var),
               apply(eps25_x250, 2, mean),
               apply(eps25_x250, 2, var),
               apply(eps25_x450, 2, mean),
               apply(eps25_x450, 2, var)), 3)


eps5_x5=cbind(mc_l1_l5[,1], GDP_l1_l5[,1], GDP_l1_l5_trunc[,1], lap_l1_l5[,1], lap_l1_l5_trunc[,1], opt_l1_l5[,1])
eps5_x250=cbind(mc_l1_l5[,2], GDP_l1_l5[,2], GDP_l1_l5_trunc[,2], lap_l1_l5[,2], lap_l1_l5_trunc[,2], opt_l1_l5[,2])
eps5_x450=cbind(mc_l1_l5[,3], GDP_l1_l5[,3], GDP_l1_l5_trunc[,3], lap_l1_l5[,3], lap_l1_l5_trunc[,3], opt_l1_l5[,3])
r2=rbind(round(apply(eps5_x5, 2, mean), 3),
         round(apply(eps5_x5, 2, var), 3),
         round(apply(eps5_x250, 2, mean), 3),
         round(apply(eps5_x250, 2, var), 3),
         round(apply(eps5_x450, 2, mean), 3),
         round(apply(eps5_x450, 2, var), 3))



eps75_x5=cbind(mc_l1_l75[,1], GDP_l1_l75[,1], GDP_l1_l75_trunc[,1], lap_l1_l75[,1], lap_l1_l75_trunc[,1], opt_l1_l75[,1])
eps75_x250=cbind(mc_l1_l75[,2], GDP_l1_l75[,2], GDP_l1_l75_trunc[,2], lap_l1_l75[,2], lap_l1_l75_trunc[,2], opt_l1_l75[,2])
eps75_x450=cbind(mc_l1_l75[,3], GDP_l1_l75[,3], GDP_l1_l75_trunc[,3], lap_l1_l75[,3], lap_l1_l75_trunc[,3], opt_l1_l75[,3])
r3=rbind(round(apply(eps75_x5, 2, mean), 3),
         round(apply(eps75_x5, 2, var), 3),
         round(apply(eps75_x250, 2, mean),3),
         round(apply(eps75_x250, 2, var),3),
         round(apply(eps75_x450, 2, mean),3),
         round(apply(eps75_x450, 2, var),3))


##Present average L1 loss values
mu_lap=c(r1[c(1,3,5),4], r2[c(1,3,5),4],r3[c(1,3,5),4])
mu_lap_trunc=c(r1[c(1,3,5),5], r2[c(1,3,5),5],r3[c(1,3,5),5])
mu_opt=c(r1[c(1,3,5),6], r2[c(1,3,5),6],r3[c(1,3,5),6])
mu_GDP=c(r1[c(1,3,5),2], r2[c(1,3,5),2],r3[c(1,3,5),2])
mu_GDP_trunc=c(r1[c(1,3,5),3], r2[c(1,3,5),3],r3[c(1,3,5),3])
mu_MR=c(r1[c(1,3,5),1], r2[c(1,3,5),1],r3[c(1,3,5),1])
tab1=rbind(mu_opt,mu_lap,mu_lap_trunc,mu_GDP,mu_GDP_trunc,mu_MR)


##Present variance of L1 loss values
var_lap=c(r1[c(2,4,6), 4], r2[c(2,4,6), 4],r3[c(2,4,6), 4])
var_lap_trunc=c(r1[c(2,4,6), 5], r2[c(2,4,6), 5],r3[c(2,4,6), 5])
var_opt=c(r1[c(2,4,6),6], r2[c(2,4,6),6],r3[c(2,4,6),6])
var_GDP=c(r1[c(2,4,6), 2], r2[c(2,4,6), 2],r3[c(2,4,6), 2])
var_GDP_trunc=c(r1[c(2,4,6), 3], r2[c(2,4,6), 3],r3[c(2,4,6),3])
var_MR=c(r1[c(2,4,6),1], r2[c(2,4,6),1],r3[c(2,4,6),1])
tab2=rbind(var_opt,var_lap,var_lap_trunc, var_GDP, var_GDP_trunc, var_MR)



####Box-plots comparing L1 loss for all the methods###
pdf("utilitycom_l1_eps25_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
boxplot(eps25_x5, ylim=c(0,250),xlab='Epsilon=0.25, i=5', ylab='L1 Loss',names=c('MR','GDP','TGDP', 'Lap','TLap','Opt'))
boxplot(eps25_x250, ylim=c(0,80),xlab='Epsilon=0.25, i=200', ylab='L1 Loss',names=c('MR','GDP','TGDP', 'Lap','TLap','Opt'))
boxplot(eps25_x450, ylim=c(0,220),xlab='Epsilon=0.25, i=450', ylab='L1 Loss',names=c('MR','GDP','TGDP', 'Lap','TLap','Opt'))
dev.off()

pdf("utilitycom_l1_eps5_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
boxplot(eps5_x5, ylim=c(0,250),xlab='Epsilon=0.5, i=5', ylab='L1 Loss',names=c('MR','GDP','TGDP', 'Lap','TLap','Opt'))
boxplot(eps5_x250, ylim=c(0,75),xlab='Epsilon=0.5, i=200', ylab='L1 Loss',names=c('MR','GDP','TGDP', 'Lap','TLap','Opt'))
boxplot(eps5_x450, ylim=c(0,200),xlab='Epsilon=0.5, i=450', ylab='L1 Loss',names=c('MR','GDP','TGDP', 'Lap','TLap','Opt'))
dev.off()

pdf("utilitycom_l1_eps75_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
boxplot(eps75_x5, ylim=c(0,220),xlab='Epsilon=0.75, i=5', ylab='L1 Loss',names=c('MR','GDP','TGDP', 'Lap','TLap','Opt'))
boxplot(eps75_x250, ylim=c(0,70),xlab='Epsilon=0.75, i=200', ylab='L1 Loss',names=c('MR','GDP','TGDP', 'Lap','TLap','Opt'))
boxplot(eps75_x450, ylim=c(0,180),xlab='Epsilon=0.75, i=450', ylab='L1 Loss',names=c('MR','GDP','TGDP', 'Lap','TLap','Opt'))
dev.off()





#######Goodness of fit testing#######
###Multiple cell testing###

##Evaluate empirical type I errors
#Lap naive
set.seed(1)
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
#typeI_multiple_lap_naive(eps, size, n, p0, alpha)

n=100
res_lap_multi_typeI_n100=NULL
for (i in 1:100){
  typeI_c=c(typeI_multiple_lap_naive(eps=0.25, size, n, p0, alpha),
            typeI_multiple_lap_naive(eps=0.5, size, n, p0, alpha),
            typeI_multiple_lap_naive(eps=0.75, size, n, p0, alpha))
  res_lap_multi_typeI_n100=rbind(res_lap_multi_typeI_n100, typeI_c)
}

round(apply(res_lap_multi_typeI_n100, 2, mean)/100,3) 


n=1000
res_lap_multi_typeI_n1000=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_lap_naive(eps=0.25, size, n, p0, alpha),
            typeI_multiple_lap_naive(eps=0.5, size, n, p0, alpha),
            typeI_multiple_lap_naive(eps=0.75, size, n, p0, alpha))
  res_lap_multi_typeI_n1000=rbind(res_lap_multi_typeI_n1000, typeI_c)
}
res_lap_multi_typeI_n1000=res_lap_multi_typeI_n1000[2:101,]
round(apply(res_lap_multi_typeI_n1000, 2, mean)/100,3) 




#Opt mechanism naive
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=100
p=rep(1/(n+1), n+1)
opt_mat25=perturbation_matrix(n, eps=0.25, p)
opt_mat5=perturbation_matrix(n, eps=0.5, p)
opt_mat75=perturbation_matrix(n, eps=0.75, p)
res_opt_multi_typeI_n100=c(1,1,1)

for (i in 1:100){
  typeI_c=c(typeI_multiple_opt_naive(opt_mat=opt_mat25,eps=0.25, size, n, p0, alpha, p),
            typeI_multiple_opt_naive(opt_mat=opt_mat5,eps=0.5, size, n, p0, alpha,p),
            typeI_multiple_opt_naive(opt_mat=opt_mat75,eps=0.75, size, n, p0, alpha,p))
  res_opt_multi_typeI_n100=rbind(res_opt_multi_typeI_n100, typeI_c)
}
res_opt_multi_typeI_n100=res_opt_multi_typeI_n100[2:101,]
round(apply(res_opt_multi_typeI_n100, 2, mean)/100,3) 

n=1000
p=rep(1/(n+1), n+1)
opt_mat25=perturbation_matrix(n, eps=0.25, p)
opt_mat5=perturbation_matrix(n, eps=0.5, p)
opt_mat75=perturbation_matrix(n, eps=0.75, p)
res_opt_multi_typeI_n1000=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_opt_naive(opt_mat=opt_mat25, eps=0.25, size, n, p0, alpha,p),
            typeI_multiple_opt_naive(opt_mat=opt_mat5,eps=0.5, size, n, p0, alpha,p),
            typeI_multiple_opt_naive(opt_mat=opt_mat75,eps=0.75, size, n, p0, alpha,p))
  res_opt_multi_typeI_n1000=rbind(res_opt_multi_typeI_n1000, typeI_c)
}
res_opt_multi_typeI_n1000=res_opt_multi_typeI_n1000[2:101,]
round(apply(res_opt_multi_typeI_n1000, 2, mean)/100,3)



#GDP naive
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=100
delta=1/n
res_GDP_multi_typeI_n100=NULL
set.seed(1)
for (i in 1:100){
  typeI_c=c(type1_GDP_naive(eps=0.25, delta, n, p0, alpha, size),
            type1_GDP_naive(eps=0.5, delta, n,  p0, alpha, size),
            type1_GDP_naive(eps=0.75, delta, n, p0, alpha, size))
  res_GDP_multi_typeI_n100=rbind(res_GDP_multi_typeI_n100, typeI_c)
}

round(apply(res_GDP_multi_typeI_n100, 2, mean)/100,3) 


n=1000
delta=1/n
res_GDP_multi_typeI_n1000=NULL
set.seed(1)
for (i in 1:100){
  typeI_c=c(type1_GDP_naive_trunc(eps=0.25, delta, n, p0, alpha, size),
            type1_GDP_naive_trunc(eps=0.5, delta, n,  p0, alpha, size),
            type1_GDP_naive_trunc(eps=0.75, delta, n, p0, alpha, size))
  res_GDP_multi_typeI_n1000=rbind(res_GDP_multi_typeI_n1000, typeI_c)
}

round(apply(res_GDP_multi_typeI_n1000, 2, mean)/100,3)




#TLap naive
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05

n=100
res_lap_multi_typeI_n100=NULL
for (i in 1:100){
  typeI_c=c(typeI_multiple_lap_naive_trunc(eps=0.25, size, n, p0, alpha),
            typeI_multiple_lap_naive_trunc(eps=0.5, size, n, p0, alpha),
            typeI_multiple_lap_naive_trunc(eps=0.75, size, n, p0, alpha))
  res_lap_multi_typeI_n100=rbind(res_lap_multi_typeI_n100, typeI_c)
}

round(apply(res_lap_multi_typeI_n100, 2, mean)/100,3) 


n=1000
res_lap_multi_typeI_n1000=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_lap_naive_trunc(eps=0.25, size, n, p0, alpha),
            typeI_multiple_lap_naive_trunc(eps=0.5, size, n, p0, alpha),
            typeI_multiple_lap_naive_trunc(eps=0.75, size, n, p0, alpha))
  res_lap_multi_typeI_n1000=rbind(res_lap_multi_typeI_n1000, typeI_c)
}
res_lap_multi_typeI_n1000=res_lap_multi_typeI_n1000[2:101,]
round(apply(res_lap_multi_typeI_n1000, 2, mean)/100,3)




#TGDP naive
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=100
delta=1/n
res_GDP_multi_typeI_n100_trunc=NULL
set.seed(1)
for (i in 1:100){
  typeI_c=c(type1_GDP_naive_trunc(eps=0.25, delta, n, p0, alpha, size),
            type1_GDP_naive_trunc(eps=0.5, delta, n,  p0, alpha, size),
            type1_GDP_naive_trunc(eps=0.75, delta, n, p0, alpha, size))
  res_GDP_multi_typeI_n100_trunc=rbind(res_GDP_multi_typeI_n100_trunc, typeI_c)
}

round(apply(res_GDP_multi_typeI_n100_trunc, 2, mean)/100,3) 


n=1000
delta=1/n
res_GDP_multi_typeI_n1000_trunc=NULL
set.seed(1)
for (i in 1:100){
  typeI_c=c(type1_GDP_naive_trunc(eps=0.25, delta, n, p0, alpha, size),
            type1_GDP_naive_trunc(eps=0.5, delta, n,  p0, alpha, size),
            type1_GDP_naive_trunc(eps=0.75, delta, n, p0, alpha, size))
  res_GDP_multi_typeI_n1000_trunc=rbind(res_GDP_multi_typeI_n1000_trunc, typeI_c)
}

round(apply(res_GDP_multi_typeI_n1000_trunc, 2, mean)/100,3)


##Explore empirical type I errors using the proposed inference procedures 
#Lap 
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=100
set.seed(8)
res_lap_multi_typeI_n100=c(1,1,1)
for (i in 1:100){
  typeI_c=c(type1_lap(eps=0.25, n, p0, alpha, size),
            type1_lap(eps=0.5, n, p0, alpha, size),
            type1_lap(eps=0.75, n, p0, alpha, size))
  res_lap_multi_typeI_n100=rbind(res_lap_multi_typeI_n100, typeI_c)
}
res_lap_multi_typeI_n100=res_lap_multi_typeI_n100[2:101,]
round(apply(res_lap_multi_typeI_n100, 2, mean)/100,3) 

n=1000
set.seed(1)
res_lap_multi_typeI_n1000=c(1,1,1)
for (i in 1:100){
  typeI_c=c(type1_lap(eps=0.25, n, p0, alpha, size),
            type1_lap(eps=0.5, n, p0, alpha, size),
            type1_lap(eps=0.75, n, p0, alpha, size))
  res_lap_multi_typeI_n1000=rbind(res_lap_multi_typeI_n1000, typeI_c)
}
res_lap_multi_typeI_n1000=res_lap_multi_typeI_n1000[2:101,]
round(apply(res_lap_multi_typeI_n1000, 2, mean)/100,3) 




#TLap
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=100
set.seed(8)
res_lap_multi_typeI_n100=c(1,1,1)
for (i in 1:100){
  typeI_c=c(type1_lap_trunc(eps=0.25, n, p0, alpha, size),
            type1_lap_trunc(eps=0.5, n, p0, alpha, size),
            type1_lap_trunc(eps=0.75, n, p0, alpha, size))
  res_lap_multi_typeI_n100=rbind(res_lap_multi_typeI_n100, typeI_c)
}
res_lap_multi_typeI_n100=res_lap_multi_typeI_n100[2:101,]
round(apply(res_lap_multi_typeI_n100, 2, mean)/100,3) 


n=1000
set.seed(1)
res_lap_multi_typeI_n1000=c(1,1,1)
for (i in 1:100){
  typeI_c=c(type1_lap_trunc(eps=0.25, n, p0, alpha, size),
            type1_lap_trunc(eps=0.5, n, p0, alpha, size),
            type1_lap_trunc(eps=0.75, n, p0, alpha, size))
  res_lap_multi_typeI_n1000=rbind(res_lap_multi_typeI_n1000, typeI_c)
}
res_lap_multi_typeI_n1000=res_lap_multi_typeI_n1000[2:101,]
round(apply(res_lap_multi_typeI_n1000, 2, mean)/100,3) 





#Opt with bias reduction
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=100
p=rep(1/(n+1), n+1)
opt_mat25=perturbation_matrix(n, eps=0.25, p)
opt_mat5=perturbation_matrix(n, eps=0.5, p)
opt_mat75=perturbation_matrix(n, eps=0.75, p)
set.seed(1)
res_opt_multi_typeI_n100_tv_bc=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_opt_with_bias_reduction(opt_mat=opt_mat25,eps=0.25, size, n, p0, alpha, p),
            typeI_multiple_opt_with_bias_reduction(opt_mat=opt_mat5,eps=0.5, size, n, p0, alpha, p),
            typeI_multiple_opt_with_bias_reduction(opt_mat=opt_mat75,eps=0.75, size, n, p0, alpha, p))
  res_opt_multi_typeI_n100_tv_bc=rbind(res_opt_multi_typeI_n100_tv_bc, typeI_c)
}
res_opt_multi_typeI_n100_tv_bc=res_opt_multi_typeI_n100_tv_bc[2:101,]
round(apply(res_opt_multi_typeI_n100_tv_bc, 2, mean)/100,3) 

set.seed(1)
n=1000
p=rep(1/(n+1), n+1)
opt_mat25=perturbation_matrix(n, eps=0.25, p)
opt_mat5=perturbation_matrix(n, eps=0.5, p)
opt_mat75=perturbation_matrix(n, eps=0.75, p)
res_opt_multi_typeI_n1000_tv_bc=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_opt_with_bias_reduction(opt_mat=opt_mat25,eps=0.25, size, n, p0, alpha, p),
            typeI_multiple_opt_with_bias_reduction(opt_mat=opt_mat5,eps=0.5, size, n, p0, alpha, p),
            typeI_multiple_opt_with_bias_reduction(opt_mat=opt_mat75, eps=0.75, size, n, p0, alpha, p))
  res_opt_multi_typeI_n1000_tv_bc=rbind(res_opt_multi_typeI_n1000_tv_bc, typeI_c)
}
res_opt_multi_typeI_n1000_tv_bc=res_opt_multi_typeI_n1000_tv_bc[2:101, ]
round(apply(res_opt_multi_typeI_n1000_tv_bc, 2, mean)/100, 3) 


##GDP
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=100
delta=1/n
set.seed(1)
res_GDP_multi_typeI_n100_tv_bc=c(1,1,1)
for (i in 1:100){
  typeI_c=c(type1_GDP(eps=0.25, delta, n, p0, alpha, size),
            type1_GDP(eps=0.5, delta, n, p0, alpha, size),
            type1_GDP(eps=0.75, delta, n, p0, alpha, size))
  res_GDP_multi_typeI_n100_tv_bc=rbind(res_GDP_multi_typeI_n100_tv_bc, typeI_c)
}
res_GDP_multi_typeI_n100_tv_bc=res_GDP_multi_typeI_n100_tv_bc[2:101,]
round(apply(res_GDP_multi_typeI_n100_tv_bc, 2, mean)/100,3) #0.052 0.051 0.051



set.seed(1)
n=1000
delta=1/n
res_GDP_multi_typeI_n1000_tv_bc=c(1,1,1)
for (i in 1:100){
  typeI_c=c(type1_GDP(eps=0.25, delta, n, p0, alpha, size),
            type1_GDP(eps=0.5, delta, n, p0, alpha, size),
            type1_GDP(eps=0.75, delta, n, p0, alpha, size))
  res_GDP_multi_typeI_n1000_tv_bc=rbind(res_GDP_multi_typeI_n1000_tv_bc, typeI_c)
}
res_GDP_multi_typeI_n1000_tv_bc=res_GDP_multi_typeI_n1000_tv_bc[2:101,]
round(apply(res_GDP_multi_typeI_n1000_tv_bc, 2, mean)/100,3) 


##TGDP
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=100
delta=1/n
set.seed(8)
res_GDP_multi_typeI_n100_tv_bc=c(1,1,1)
for (i in 1:100){
  typeI_c=c(type1_GDP_trunc(eps=0.25, delta, n, p0, alpha, size),
            type1_GDP_trunc(eps=0.5, delta, n, p0, alpha, size),
            type1_GDP_trunc(eps=0.75, delta, n, p0, alpha, size))
  res_GDP_multi_typeI_n100_tv_bc=rbind(res_GDP_multi_typeI_n100_tv_bc, typeI_c)
}
res_GDP_multi_typeI_n100_tv_bc=res_GDP_multi_typeI_n100_tv_bc[2:101,] 
round(apply(res_GDP_multi_typeI_n100_tv_bc, 2, mean)/100,3) 


set.seed(1)
n=1000
delta=1/n
res_GDP_multi_typeI_n1000_tv_bc=c(1,1,1)
for (i in 1:100){
  typeI_c=c(type1_GDP_trunc(eps=0.25, delta, n, p0, alpha, size),
            type1_GDP_trunc(eps=0.5, delta, n, p0, alpha, size),
            type1_GDP_trunc(eps=0.75, delta, n, p0, alpha, size))
  res_GDP_multi_typeI_n1000_tv_bc=rbind(res_GDP_multi_typeI_n1000_tv_bc, typeI_c)
}
res_GDP_multi_typeI_n1000_tv_bc=res_GDP_multi_typeI_n1000_tv_bc[2:101,]
round(apply(res_GDP_multi_typeI_n1000_tv_bc, 2, mean)/100,3) 






#####To compare the empirical power of the Lap, TLap, Opt, GDP and TGDP (figure 2)####
##Lap 
#eps=0.25, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.25
set.seed(1)
p_n100_eps0.25_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple(n, p0, alpha, size, p1, eps)
  p_n100_eps0.25_lap=c(p_n100_eps0.25_lap, pow)
}

#eps=0.5, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.5

p_n100_eps0.5_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple(n, p0, alpha, size, p1, eps)
  p_n100_eps0.5_lap=c(p_n100_eps0.5_lap, pow)
}

#eps=0.75, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.75

p_n100_eps0.75_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple(n, p0, alpha, size, p1, eps)
  p_n100_eps0.75_lap=c(p_n100_eps0.75_lap, pow)
}
#eps=0.25, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.25
set.seed(1)
p_n1000_eps0.25_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple(n, p0, alpha, size, p1, eps)
  p_n1000_eps0.25_lap=c(p_n1000_eps0.25_lap, pow)
}
#eps=0.5, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.5
set.seed(1)
p_n1000_eps0.5_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple(n, p0, alpha, size, p1, eps)
  p_n1000_eps0.5_lap=c(p_n1000_eps0.5_lap, pow)
}


#eps=0.75, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.75
set.seed(1)
p_n1000_eps0.75_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple(n, p0, alpha, size, p1, eps)
  p_n1000_eps0.75_lap=c(p_n1000_eps0.75_lap, pow)
}



##GDP
#eps=0.25, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.25
delta=1/n
set.seed(1)
p_n100_eps0.25_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple(n, p0, alpha, size, p1, eps, delta)
  p_n100_eps0.25_GDP=c(p_n100_eps0.25_GDP, pow)
}

#eps=0.5, n=100
eps=0.5
set.seed(1)
p_n100_eps0.5_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple(n, p0, alpha, size, p1, eps, delta)
  p_n100_eps0.5_GDP=c(p_n100_eps0.5_GDP, pow)
}

#eps=0.75, n=100
eps=0.75
set.seed(1)
p_n100_eps0.75_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple(n, p0, alpha, size, p1, eps, delta)
  p_n100_eps0.75_GDP=c(p_n100_eps0.75_GDP, pow)
}

#eps=0.25, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.25
delta=1/n
set.seed(1)
p_n1000_eps0.25_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple(n, p0, alpha, size, p1, eps, delta)
  p_n1000_eps0.25_GDP=c(p_n1000_eps0.25_GDP, pow)
}
#eps=0.5, n=1000
eps=0.5
set.seed(1)
p_n1000_eps0.5_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple(n, p0, alpha, size, p1, eps, delta)
  p_n1000_eps0.5_GDP=c(p_n1000_eps0.5_GDP, pow)
}

#eps=0.75, n=1000
eps=0.75
set.seed(1)
p_n1000_eps0.75_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple(n, p0, alpha, size, p1, eps, delta)
  p_n1000_eps0.75_GDP=c(p_n1000_eps0.75_GDP, pow)
}



##TLap
#eps=0.25, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.25
set.seed(1)
p_n100_eps0.25_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple_trunc(n, p0, alpha, size, p1, eps)
  p_n100_eps0.25_lap_trunc=c(p_n100_eps0.25_lap_trunc, pow)
}

#eps=0.5, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.5
p_n100_eps0.5_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple_trunc(n, p0, alpha, size, p1, eps)
  p_n100_eps0.5_lap_trunc=c(p_n100_eps0.5_lap_trunc, pow)
}

#eps=0.75, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.75
set.seed(1)
p_n100_eps0.75_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple_trunc(n, p0, alpha, size, p1, eps)
  p_n100_eps0.75_lap_trunc=c(p_n100_eps0.75_lap_trunc, pow)
}

#eps=0.25, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.25
set.seed(1)
p_n1000_eps0.25_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple_trunc(n, p0, alpha, size, p1, eps)
  p_n1000_eps0.25_lap_trunc=c(p_n1000_eps0.25_lap_trunc, pow)
}
#eps=0.5, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.5
set.seed(1)
p_n1000_eps0.5_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple_trunc(n, p0, alpha, size, p1, eps)
  p_n1000_eps0.5_lap_trunc=c(p_n1000_eps0.5_lap_trunc, pow)
}


#eps=0.75, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.75
set.seed(1)
p_n1000_eps0.75_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_lap_multiple_trunc(n, p0, alpha, size, p1, eps)
  p_n1000_eps0.75_lap_trunc=c(p_n1000_eps0.75_lap_trunc, pow)
}




##TGDP
#eps=0.25, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.25
delta=1/n
set.seed(1)
p_n100_eps0.25_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple_trunc(n, p0, alpha, size, p1, eps, delta)
  p_n100_eps0.25_GDP_trunc=c(p_n100_eps0.25_GDP_trunc, pow)
}

#eps=0.5, n=100
eps=0.5
set.seed(1)
p_n100_eps0.5_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple_trunc(n, p0, alpha, size, p1, eps, delta)
  p_n100_eps0.5_GDP_trunc=c(p_n100_eps0.5_GDP_trunc, pow)
}

#eps=0.75, n=100
eps=0.75
set.seed(1)
p_n100_eps0.75_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple_trunc(n, p0, alpha, size, p1, eps, delta)
  p_n100_eps0.75_GDP_trunc=c(p_n100_eps0.75_GDP_trunc, pow)
}

#eps=0.25, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.25
delta=1/n
set.seed(1)
p_n1000_eps0.25_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple_trunc(n, p0, alpha, size, p1, eps, delta)
  p_n1000_eps0.25_GDP_trunc=c(p_n1000_eps0.25_GDP_trunc, pow)
}
#eps=0.5, n=1000
eps=0.5
set.seed(1)
p_n1000_eps0.5_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple_trunc(n, p0, alpha, size, p1, eps, delta)
  p_n1000_eps0.5_GDP_trunc=c(p_n1000_eps0.5_GDP_trunc, pow)
}

#eps=0.75, n=1000
eps=0.75
set.seed(1)
p_n1000_eps0.75_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_GDP_multiple_trunc(n, p0, alpha, size, p1, eps, delta)
  p_n1000_eps0.75_GDP_trunc=c(p_n1000_eps0.75_GDP_trunc, pow)
}








##Opt without bias correction
#eps=0.25, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
p=rep(1/(n+1), n+1)
alpha=0.05 
size=500
eps=0.25
opt_mat=perturbation_matrix(n, eps, p)
set.seed(4)
p_n100_eps0.25_opt=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_without_bias_reduction(opt_mat, eps, size, n, p0, alpha, p1)
  p_n100_eps0.25_opt=c(p_n100_eps0.25_opt, pow)
}

#eps=0.5, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
p=rep(1/(n+1), n+1)
alpha=0.05 
size=500
eps=0.5
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n100_eps0.5_opt=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_without_bias_reduction(opt_mat, eps, size, n, p0, alpha, p1)
  p_n100_eps0.5_opt=c(p_n100_eps0.5_opt, pow)
}

#eps=0.75, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
p=rep(1/(n+1), n+1)
alpha=0.05 
size=500
eps=0.75
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n100_eps0.75_opt=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_without_bias_reduction(opt_mat, eps, size, n, p0, alpha, p1)
  p_n100_eps0.75_opt=c(p_n100_eps0.75_opt, pow)
}


#eps=0.25, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
p=rep(1/(n+1), n+1)
alpha=0.05 
size=500
eps=0.25
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n1000_eps0.25_opt=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_without_bias_reduction(opt_mat, eps, size, n, p0, alpha, p1)
  p_n1000_eps0.25_opt=c(p_n1000_eps0.25_opt, pow)
}

#eps=0.5, n=100
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
p=rep(1/(n+1), n+1)
alpha=0.05 
size=500
eps=0.5
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n1000_eps0.5_opt=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_without_bias_reduction(opt_mat, eps, size, n, p0, alpha, p1)
  p_n1000_eps0.5_opt=c(p_n1000_eps0.5_opt, pow)
}

#eps=0.75, n=100
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
p=rep(1/(n+1), n+1)
alpha=0.05 
size=500
eps=0.75
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n1000_eps0.75_opt=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_without_bias_reduction(opt_mat, eps, size, n, p0, alpha, p1)
  p_n1000_eps0.75_opt=c(p_n1000_eps0.75_opt, pow)
}


##Opt with bias correction
#eps=0.25, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.25
p=rep(1/(n+1), n+1)
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n100_eps0.25_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_with_bias_reduction(opt_mat, eps, size, n, p0, alpha, p1)
  p_n100_eps0.25_opt_c=c(p_n100_eps0.25_opt_c, pow)
}

#eps=0.5, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.5
p=rep(1/(n+1), n+1)
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n100_eps0.5_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_with_bias_reduction(opt_mat,eps, size, n, p0, alpha, p1)
  p_n100_eps0.5_opt_c=c(p_n100_eps0.5_opt_c, pow)
}

#eps=0.75, n=100
p_v=seq(0.1, 0.25, 0.01)
n=100 
p0=c(0.1, 0.1, 0.8) 
alpha=0.05 
size=500
eps=0.75
p=rep(1/(n+1), n+1)
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n100_eps0.75_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_with_bias_reduction(opt_mat,eps, size, n, p0, alpha, p1)
  p_n100_eps0.75_opt_c=c(p_n100_eps0.75_opt_c, pow)
}


#eps=0.25, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
p=rep(1/(n+1), n+1)
alpha=0.05 
size=500
eps=0.25
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n1000_eps0.25_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_with_bias_reduction(opt_mat,eps, size, n, p0, alpha, p1)
  p_n1000_eps0.25_opt_c=c(p_n1000_eps0.25_opt_c, pow)
}

#eps=0.5, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
p=rep(1/(n+1), n+1)
alpha=0.05 
size=500
eps=0.5
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n1000_eps0.5_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_with_bias_reduction(opt_mat,eps, size, n, p0, alpha, p1)
  p_n1000_eps0.5_opt_c=c(p_n1000_eps0.5_opt_c, pow)
}

#eps=0.75, n=1000
p_v=seq(0.1, 0.135, 0.0025)
n=1000 
p0=c(0.1, 0.1, 0.8) 
p=rep(1/(n+1), n+1)
alpha=0.05 
size=500
eps=0.75
opt_mat=perturbation_matrix(n, eps, p)
set.seed(1)
p_n1000_eps0.75_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_multiple_opt_with_bias_reduction(opt_mat,eps, size, n, p0, alpha, p1)
  p_n1000_eps0.75_opt_c=c(p_n1000_eps0.75_opt_c, pow)
}






##Plot empirical power across different methods
pdf("power_all_n100_multiplecell_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
p_v=seq(0.1, 0.25, 0.01)
plot(p_v, p_n100_eps0.25_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.25 (n=100)', lty=1, col='blue')
points(p_v,  p_n100_eps0.25_lap/100, col="red", pch="*")
lines(p_v, p_n100_eps0.25_lap/100, col="red",lty=2)
points(p_v,  p_n100_eps0.25_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n100_eps0.25_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n100_eps0.25_GDP/100, col="black",pch="+")
lines(p_v,  p_n100_eps0.25_GDP/100, col="black", lty=3)
points(p_v,  p_n100_eps0.25_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n100_eps0.25_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)

plot(p_v, p_n100_eps0.5_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.5 (n=100)', lty=1, col='blue')
points(p_v,  p_n100_eps0.5_lap/100, col="red", pch="*")
lines(p_v, p_n100_eps0.5_lap/100, col="red",lty=2)
points(p_v,  p_n100_eps0.5_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n100_eps0.5_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n100_eps0.5_GDP/100, col="black",pch="+")
lines(p_v,  p_n100_eps0.5_GDP/100, col="black", lty=3)
points(p_v,  p_n100_eps0.5_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n100_eps0.5_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)


plot(p_v, p_n100_eps0.75_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.75 (n=100)', lty=1, col='blue')
points(p_v,  p_n100_eps0.75_lap/100, col="red", pch="*")
lines(p_v, p_n100_eps0.75_lap/100, col="red",lty=2)
points(p_v,  p_n100_eps0.75_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n100_eps0.75_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n100_eps0.75_GDP/100, col="black",pch="+")
lines(p_v,  p_n100_eps0.75_GDP/100, col="black", lty=3)
points(p_v,  p_n100_eps0.75_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n100_eps0.75_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)

dev.off()



pdf("power_all_n1000_multiplecell_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
p_v=seq(0.1, 0.135, 0.0025)
plot(p_v, p_n1000_eps0.25_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.25 (n=1000)', lty=1, col='blue')
points(p_v,  p_n1000_eps0.25_lap/100, col="red", pch="*")
lines(p_v, p_n1000_eps0.25_lap/100, col="red",lty=2)
points(p_v,  p_n1000_eps0.25_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n1000_eps0.25_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n1000_eps0.25_GDP/100, col="black",pch="+")
lines(p_v,  p_n1000_eps0.25_GDP/100, col="black", lty=3)
points(p_v,  p_n1000_eps0.25_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n1000_eps0.25_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)


plot(p_v, p_n1000_eps0.5_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.5 (n=1000)', lty=1, col='blue')
points(p_v,  p_n1000_eps0.5_lap/100, col="red", pch="*")
lines(p_v, p_n1000_eps0.5_lap/100, col="red",lty=2)
points(p_v,  p_n1000_eps0.5_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n1000_eps0.5_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n1000_eps0.5_GDP/100, col="black",pch="+")
lines(p_v,  p_n1000_eps0.5_GDP/100, col="black", lty=3)
points(p_v,  p_n1000_eps0.5_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n1000_eps0.5_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)


plot(p_v, p_n1000_eps0.75_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.75 (n=1000)', lty=1, col='blue')
points(p_v,  p_n1000_eps0.75_lap/100, col="red", pch="*")
lines(p_v, p_n1000_eps0.75_lap/100, col="red",lty=2)
points(p_v,  p_n1000_eps0.75_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n1000_eps0.75_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n1000_eps0.75_GDP/100, col="black",pch="+")
lines(p_v,  p_n1000_eps0.75_GDP/100, col="black", lty=3)
points(p_v,  p_n1000_eps0.75_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n1000_eps0.75_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)


dev.off()



#Compare empirical powers for Opt with and without bias correction
pdf("power_n100_bias_correction_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
p_v=seq(0.1, 0.25, 0.01)
plot(p_v, p_n100_eps0.25_opt/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.25 (n=100)', lty=1, col='blue')
points(p_v,  p_n100_eps0.25_opt_c/100, col="red",pch="+")
lines(p_v,  p_n100_eps0.25_opt_c/100, col="red", lty=3)
legend(0.1,1,legend=c("no correction","with correction"), col=c("blue","red"),
       pch=c("o","+"),lty=c(1,3), ncol=1)

plot(p_v, p_n100_eps0.5_opt/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.5 (n=100)', lty=1, col='blue')
points(p_v,  p_n100_eps0.5_opt_c/100, col="red",pch="+")
lines(p_v,  p_n100_eps0.5_opt_c/100, col="red", lty=3)
legend(0.1,1,legend=c("no correction","with correction"), col=c("blue","red"),
       pch=c("o","+"),lty=c(1,3), ncol=1)


plot(p_v, p_n100_eps0.75_opt/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.75 (n=100)', lty=1, col='blue')
points(p_v,  p_n100_eps0.75_opt_c/100, col="red",pch="+")
lines(p_v,  p_n100_eps0.75_opt_c/100, col="red", lty=3)
legend(0.1,1,legend=c("no correction","with correction"), col=c("blue","red"),
       pch=c("o","+"),lty=c(1,3), ncol=1)

dev.off()


pdf("power_n1000_bias_correction_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
p_v=seq(0.1, 0.135, by=0.0025)
plot(p_v, p_n1000_eps0.25_opt/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.25 (n=1000)', lty=1, col='blue', xlim=c(0.1, 0.14))
points(p_v,  p_n1000_eps0.25_opt_c/100, col="red",pch="+")
lines(p_v,  p_n1000_eps0.25_opt_c/100, col="red", lty=3)
legend(0.1,1,legend=c("no correction","with correction"), col=c("blue","red"),
       pch=c("o","+"),lty=c(1,3), ncol=1)

plot(p_v, p_n1000_eps0.5_opt/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.5 (n=1000)', lty=1, col='blue', xlim=c(0.1, 0.14))
points(p_v,  p_n1000_eps0.5_opt_c/100, col="red",pch="+")
lines(p_v,  p_n1000_eps0.5_opt_c/100, col="red", lty=3)
legend(0.1,1,legend=c("no correction","with correction"), col=c("blue","red"),
       pch=c("o","+"),lty=c(1,3), ncol=1)

plot(p_v, p_n1000_eps0.75_opt/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.75 (n=1000)', lty=1, col='blue', xlim=c(0.1, 0.14))
points(p_v,  p_n1000_eps0.75_opt_c/100, col="red",pch="+")
lines(p_v,  p_n1000_eps0.75_opt_c/100, col="red", lty=3)
legend(0.1,1,legend=c("no correction","with correction"), col=c("blue","red"),
       pch=c("o","+"),lty=c(1,3), ncol=1)

dev.off()


######Inter-table merging#######
#We try to merge two tables
#First explore the empirical type I errors

#Lap
#When n1+n2=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
set.seed(1)
typeI_c=c(type1_merge_lap(eps=0.25, n1, n2, p0, alpha, size),
          type1_merge_lap(eps=0.5, n1, n2, p0, alpha, size),
          type1_merge_lap(eps=0.75, n1, n2, p0, alpha, size))
round(typeI_c/100,3)

#When n1+n2=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
set.seed(2)
typeI_c=c(type1_merge_lap(eps=0.25, n1, n2, p0, alpha, size),
          type1_merge_lap(eps=0.5, n1, n2, p0, alpha, size),
          type1_merge_lap(eps=0.75, n1, n2, p0, alpha, size))
round(typeI_c/100,3)



#TLap
#When n1+n2=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
set.seed(1)
typeI_c=c(type1_merge_lap_trunc(eps=0.25, n1, n2, p0, alpha, size),
          type1_merge_lap_trunc(eps=0.5, n1, n2, p0, alpha, size),
          type1_merge_lap_trunc(eps=0.75, n1, n2, p0, alpha, size))
round(typeI_c/100,3)


#When n1+n2=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
set.seed(2)
typeI_c=c(type1_merge_lap_trunc(eps=0.25, n1, n2, p0, alpha, size),
          type1_merge_lap_trunc(eps=0.5, n1, n2, p0, alpha, size),
          type1_merge_lap_trunc(eps=0.75, n1, n2, p0, alpha, size))
round(typeI_c/100,3)



#GDP
#When n1+n2=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
set.seed(1)
typeI_c=c(type1_merge_GDP(eps, n1, n2, p0, alpha, size),
          type1_merge_GDP(eps, n1, n2, p0, alpha, size),
          type1_merge_GDP(eps, n1, n2, p0, alpha, size))
round(typeI_c/100,3)

#When n1+n2=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
set.seed(1)
typeI_c=c(type1_merge_GDP(eps, n1, n2, p0, alpha, size),
          type1_merge_GDP(eps, n1, n2, p0, alpha, size),
          type1_merge_GDP(eps, n1, n2, p0, alpha, size))
round(typeI_c/100,3)





#TGDP
#When n1+n2=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
set.seed(1)
typeI_c=c(type1_merge_GDP_trunc(eps, n1, n2, p0, alpha, size),
          type1_merge_GDP_trunc(eps, n1, n2, p0, alpha, size),
          type1_merge_GDP_trunc(eps, n1, n2, p0, alpha, size))
round(typeI_c/100,3)


#When n1+n2=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
set.seed(1)
typeI_c=c(type1_merge_GDP_trunc(eps, n1, n2, p0, alpha, size),
          type1_merge_GDP_trunc(eps, n1, n2, p0, alpha, size),
          type1_merge_GDP_trunc(eps, n1, n2, p0, alpha, size))
round(typeI_c/100,3)




#Opt
#When n1+n2=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
p1=rep(1/(n1+1), n1+1)
p2=rep(1/(n2+1), n2+1)
set.seed(2)
typeI_c=c(typeI_merge_multiple_opt_with_bias_reduction(eps=0.25, size, n1, n2, p0, alpha, p1, p2),
          typeI_merge_multiple_opt_with_bias_reduction(eps=0.5, size, n1, n2, p0, alpha, p1, p2),
          typeI_merge_multiple_opt_with_bias_reduction(eps=0.75, size, n1, n2, p0, alpha, p1, p2))
round(typeI_c/100,3)


#When n1+n2=1000
p0=c(0.2,0.4,0.4)
size=500
alpha=0.05
n1=300
n2=700
p1=rep(1/(n1+1), n1+1)
p2=rep(1/(n2+1), n2+1)
set.seed(2)
typeI_c=c(typeI_merge_multiple_opt_with_bias_reduction(eps=0.25, size, n1, n2, p0, alpha, p1, p2),
          typeI_merge_multiple_opt_with_bias_reduction(eps=0.5, size, n1, n2, p0, alpha, p1, p2),
          typeI_merge_multiple_opt_with_bias_reduction(eps=0.75, size, n1, n2, p0, alpha, p1, p2))
round(typeI_c/100,3)




#To explore the empirical powers

#Lap
#eps=0.25, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
eps=0.25
p_v=seq(0.1, 0.25, 0.01)
set.seed(1)
p_n100_eps0.25_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap(eps, n1, n2, p0, alpha, size, p1)  
  p_n100_eps0.25_lap=c(p_n100_eps0.25_lap, pow)
  
}

#eps=0.5, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
eps=0.5

p_v=seq(0.1, 0.25, 0.01)
set.seed(1)
p_n100_eps0.5_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap(eps, n1, n2, p0, alpha, size, p1)  
  p_n100_eps0.5_lap=c(p_n100_eps0.5_lap, pow)
}

#eps=0.75, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
eps=0.75

p_v=seq(0.1, 0.25, 0.01)
set.seed(1)
p_n100_eps0.75_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap(eps, n1, n2, p0, alpha, size, p1)
  p_n100_eps0.75_lap=c(p_n100_eps0.75_lap, pow)
}

#eps=0.25, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
eps=0.25

p_v=seq(0.1, 0.135, 0.0025)
eps=0.25
set.seed(1)
p_n1000_eps0.25_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.25_lap=c(p_n1000_eps0.25_lap, pow)
}

#eps=0.5, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
eps=0.5

p_v=seq(0.1, 0.135, 0.0025)
set.seed(1)
p_n1000_eps0.5_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.5_lap=c(p_n1000_eps0.5_lap, pow)
}


#eps=0.75, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
eps=0.75

p_v=seq(0.1, 0.135, 0.0025)
set.seed(1)
p_n1000_eps0.75_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.75_lap=c(p_n1000_eps0.75_lap, pow)
}







#TLap
#eps=0.25, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
eps=0.25
p_v=seq(0.1, 0.25, 0.01)
set.seed(1)
p_n100_eps0.25_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap_trunc(eps, n1, n2, p0, alpha, size, p1)  
  p_n100_eps0.25_lap_trunc=c(p_n100_eps0.25_lap_trunc, pow)
  
}

#eps=0.5, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
eps=0.5

p_v=seq(0.1, 0.25, 0.01)
set.seed(1)
p_n100_eps0.5_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap_trunc(eps, n1, n2, p0, alpha, size, p1)  
  p_n100_eps0.5_lap_trunc=c(p_n100_eps0.5_lap_trunc, pow)
}

#eps=0.75, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
eps=0.75

p_v=seq(0.1, 0.25, 0.01)
set.seed(1)
p_n100_eps0.75_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap_trunc(eps, n1, n2, p0, alpha, size, p1)
  p_n100_eps0.75_lap_trunc=c(p_n100_eps0.75_lap_trunc, pow)
}

#eps=0.25, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
eps=0.25

p_v=seq(0.1, 0.135, 0.0025)
eps=0.25
set.seed(1)
p_n1000_eps0.25_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap_trunc(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.25_lap_trunc=c(p_n1000_eps0.25_lap_trunc, pow)
}

#eps=0.5, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
eps=0.5

p_v=seq(0.1, 0.135, 0.0025)
set.seed(1)
p_n1000_eps0.5_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap_trunc(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.5_lap_trunc=c(p_n1000_eps0.5_lap_trunc, pow)
}


#eps=0.75, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
eps=0.75

p_v=seq(0.1, 0.135, 0.0025)
set.seed(1)
p_n1000_eps0.75_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_lap_trunc(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.75_lap_trunc=c(p_n1000_eps0.75_lap_trunc, pow)
}




#Opt
#eps=0.25, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
eps=0.25
pr1=rep(1/(n1+1), n1+1)
pr2=rep(1/(n2+1), n2+1)
opt_mat1=perturbation_matrix(n1, eps, pr1)
opt_mat2=perturbation_matrix(n2, eps, pr2)
p_v=seq(0.1, 0.25, 0.01)
set.seed(1)
p_n100_eps0.25_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_merge_multiple_opt_with_bias_reduction(eps, size, n1, n2, p0, alpha, p1, opt_mat1, opt_mat2)
  p_n100_eps0.25_opt_c=c(p_n100_eps0.25_opt_c, pow)
}

#eps=0.5, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
eps=0.5
pr1=rep(1/(n1+1), n1+1)
pr2=rep(1/(n2+1), n2+1)
opt_mat1=perturbation_matrix(n1, eps, pr1)
opt_mat2=perturbation_matrix(n2, eps, pr2)
p_v=seq(0.1, 0.25, 0.01)
set.seed(1)
p_n100_eps0.5_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_merge_multiple_opt_with_bias_reduction(eps, size, n1, n2, p0, alpha, p1, opt_mat1, opt_mat2)
  p_n100_eps0.5_opt_c=c(p_n100_eps0.5_opt_c, pow)
}

#eps=0.75, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
eps=0.75
pr1=rep(1/(n1+1), n1+1)
pr2=rep(1/(n2+1), n2+1)
opt_mat1=perturbation_matrix(n1, eps, pr1)
opt_mat2=perturbation_matrix(n2, eps, pr2)
p_v=seq(0.1, 0.25, 0.01)
set.seed(2)
p_n100_eps0.75_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_merge_multiple_opt_with_bias_reduction(eps, size, n1, n2, p0, alpha, p1, opt_mat1, opt_mat2)
  p_n100_eps0.75_opt_c=c(p_n100_eps0.75_opt_c, pow)
}


#eps=0.25, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
eps=0.25
pr1=rep(1/(n1+1), n1+1)
pr2=rep(1/(n2+1), n2+1)
opt_mat1=perturbation_matrix(n1, eps, pr1)
opt_mat2=perturbation_matrix(n2, eps, pr2)
p_v=seq(0.1, 0.135, 0.0025)
set.seed(1)
p_n1000_eps0.25_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_merge_multiple_opt_with_bias_reduction(eps, size, n1, n2, p0, alpha, p1, opt_mat1, opt_mat2)
  p_n1000_eps0.25_opt_c=c(p_n1000_eps0.25_opt_c, pow)
}

#eps=0.5, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
eps=0.5
pr1=rep(1/(n1+1), n1+1)
pr2=rep(1/(n2+1), n2+1)
opt_mat1=perturbation_matrix(n1, eps, pr1)
opt_mat2=perturbation_matrix(n2, eps, pr2)
p_v=seq(0.1, 0.135, 0.0025)
set.seed(1)
p_n1000_eps0.5_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_merge_multiple_opt_with_bias_reduction(eps, size, n1, n2, p0, alpha, p1, opt_mat1, opt_mat2)
  p_n1000_eps0.5_opt_c=c(p_n1000_eps0.5_opt_c, pow)
}

#eps=0.75, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
eps=0.75
pr1=rep(1/(n1+1), n1+1)
pr2=rep(1/(n2+1), n2+1)
opt_mat1=perturbation_matrix(n1, eps, pr1)
opt_mat2=perturbation_matrix(n2, eps, pr2)
p_v=seq(0.1, 0.135, 0.0025)
set.seed(1)
p_n1000_eps0.75_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=power_merge_multiple_opt_with_bias_reduction(eps, size, n1, n2, p0, alpha, p1, opt_mat1, opt_mat2)
  p_n1000_eps0.75_opt_c=c(p_n1000_eps0.75_opt_c, pow)
}



#GDP
#eps=0.25, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
p_v=seq(0.10, 0.25, 0.01)
eps=0.25
set.seed(1)
p_n100_eps0.25_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP(eps, n1, n2, p0, alpha, size, p1)
  p_n100_eps0.25_GDP=c(p_n100_eps0.25_GDP, pow)
}

#eps=0.5, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
p_v=seq(0.10, 0.25, 0.01)
eps=0.5
set.seed(1)
p_n100_eps0.5_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP(eps, n1, n2, p0, alpha, size, p1)
  p_n100_eps0.5_GDP=c(p_n100_eps0.5_GDP, pow)
}

#eps=0.75, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
p_v=seq(0.10, 0.25, 0.01)
eps=0.75
set.seed(1)
p_n100_eps0.75_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP(eps, n1, n2, p0, alpha, size, p1)
  p_n100_eps0.75_GDP=c(p_n100_eps0.75_GDP, pow)
}

#eps=0.25, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
p_v=seq(0.10, 0.135, 0.0025)
eps=0.25
set.seed(1)
p_n1000_eps0.25_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.25_GDP=c(p_n1000_eps0.25_GDP, pow)
}

#eps=0.5, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
p_v=seq(0.10, 0.135, 0.0025)
eps=0.5
set.seed(1)
p_n1000_eps0.5_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.5_GDP=c(p_n1000_eps0.5_GDP, pow)
}


#eps=0.75, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
p_v=seq(0.10, 0.135, 0.0025)
eps=0.75
set.seed(1)
p_n1000_eps0.75_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.75_GDP=c(p_n1000_eps0.75_GDP, pow)
}




#TGDP
#eps=0.25, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
p_v=seq(0.10, 0.25, 0.01)
eps=0.25
set.seed(1)
p_n100_eps0.25_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP_trunc(eps, n1, n2, p0, alpha, size, p1)
  p_n100_eps0.25_GDP_trunc=c(p_n100_eps0.25_GDP_trunc, pow)
}

#eps=0.5, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
p_v=seq(0.10, 0.25, 0.01)
eps=0.5
set.seed(1)
p_n100_eps0.5_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP_trunc(eps, n1, n2, p0, alpha, size, p1)
  p_n100_eps0.5_GDP_trunc=c(p_n100_eps0.5_GDP_trunc, pow)
}

#eps=0.75, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=30
n2=70
p_v=seq(0.10, 0.25, 0.01)
eps=0.75
set.seed(1)
p_n100_eps0.75_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP_trunc(eps, n1, n2, p0, alpha, size, p1)
  p_n100_eps0.75_GDP_trunc=c(p_n100_eps0.75_GDP_trunc, pow)
}


#eps=0.25, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
p_v=seq(0.10, 0.135, 0.0025)
eps=0.25
set.seed(1)
p_n1000_eps0.25_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP_trunc(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.25_GDP_trunc=c(p_n1000_eps0.25_GDP_trunc, pow)
}

#eps=0.5, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
p_v=seq(0.10, 0.135, 0.0025)
eps=0.5
set.seed(1)
p_n1000_eps0.5_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP_trunc(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.5_GDP_trunc=c(p_n1000_eps0.5_GDP_trunc, pow)
}


#eps=0.75, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n1=300
n2=700
p_v=seq(0.10, 0.135, 0.0025)
eps=0.75
set.seed(1)
p_n1000_eps0.75_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_merge_GDP_trunc(eps, n1, n2, p0, alpha, size, p1)
  p_n1000_eps0.75_GDP_trunc=c(p_n1000_eps0.75_GDP_trunc, pow)
}






pdf("power_merge_n100_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
p_v=seq(0.1, 0.25, 0.01)
plot(p_v, p_n100_eps0.25_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.25 (n1+n2=100)', lty=1, col='blue')
points(p_v,  p_n100_eps0.25_lap/100, col="red", pch="*")
lines(p_v, p_n100_eps0.25_lap/100, col="red",lty=2)
points(p_v,  p_n100_eps0.25_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n100_eps0.25_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n100_eps0.25_GDP/100, col="black",pch="+")
lines(p_v,  p_n100_eps0.25_GDP/100, col="black", lty=3)
points(p_v,  p_n100_eps0.25_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n100_eps0.25_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)



plot(p_v, p_n100_eps0.5_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.5 (n1+n2=100)', lty=1, col='blue')
points(p_v,  p_n100_eps0.5_lap/100, col="red", pch="*")
lines(p_v, p_n100_eps0.5_lap/100, col="red",lty=2)
points(p_v,  p_n100_eps0.5_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n100_eps0.5_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n100_eps0.5_GDP/100, col="black",pch="+")
lines(p_v,  p_n100_eps0.5_GDP/100, col="black", lty=3)
points(p_v,  p_n100_eps0.5_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n100_eps0.5_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)



plot(p_v, p_n100_eps0.75_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.75 (n1+n2=100)', lty=1, col='blue')
points(p_v,  p_n100_eps0.75_lap/100, col="red", pch="*")
lines(p_v, p_n100_eps0.75_lap/100, col="red",lty=2)
points(p_v,  p_n100_eps0.75_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n100_eps0.75_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n100_eps0.75_GDP/100, col="black",pch="+")
lines(p_v,  p_n100_eps0.75_GDP/100, col="black", lty=3)
points(p_v,  p_n100_eps0.75_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n100_eps0.75_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)

dev.off()


pdf("power_merge_n1000_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
p_v=seq(0.1, 0.135, 0.0025)
plot(p_v, p_n1000_eps0.25_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.25 (n1+n2=1000)', lty=1, col='blue')
points(p_v,  p_n1000_eps0.25_lap/100, col="red", pch="*")
lines(p_v, p_n1000_eps0.25_lap/100, col="red",lty=2)
points(p_v,  p_n1000_eps0.25_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n1000_eps0.25_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n1000_eps0.25_GDP/100, col="black",pch="+")
lines(p_v,  p_n1000_eps0.25_GDP/100, col="black", lty=3)
points(p_v,  p_n1000_eps0.25_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n1000_eps0.25_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)



plot(p_v, p_n1000_eps0.5_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.5 (n1+n2=1000)', lty=1, col='blue')
points(p_v,  p_n1000_eps0.5_lap/100, col="red", pch="*")
lines(p_v, p_n1000_eps0.5_lap/100, col="red",lty=2)
points(p_v,  p_n1000_eps0.5_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n1000_eps0.5_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n1000_eps0.5_GDP/100, col="black",pch="+")
lines(p_v,  p_n1000_eps0.5_GDP/100, col="black", lty=3)
points(p_v,  p_n1000_eps0.5_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n1000_eps0.5_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)



plot(p_v, p_n1000_eps0.75_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.75 (n1+n2=1000)', lty=1, col='blue')
points(p_v,  p_n1000_eps0.75_lap/100, col="red", pch="*")
lines(p_v, p_n1000_eps0.75_lap/100, col="red",lty=2)
points(p_v,  p_n1000_eps0.75_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n1000_eps0.75_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n1000_eps0.75_GDP/100, col="black",pch="+")
lines(p_v,  p_n1000_eps0.75_GDP/100, col="black", lty=3)
points(p_v,  p_n1000_eps0.75_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n1000_eps0.75_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)

dev.off()







#####Intra-table case simulation studies#####
##We first explore the empirical type I errors for all the methods for comparison##

#GDP
p0=c(0.1, 0.1, 0.8)
size=500
alpha=0.05
n=100
C=2
set.seed(1)
res_GDP_typeI_n100=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_GDP_intercell_merge(eps=0.25, size, n, p0, alpha, C),
            typeI_multiple_GDP_intercell_merge(eps=0.5, size, n, p0, alpha, C),
            typeI_multiple_GDP_intercell_merge(eps=0.75, size, n, p0, alpha, C))
  res_GDP_typeI_n100=rbind(res_GDP_typeI_n100, typeI_c)
}
res_GDP_typeI_n100=res_GDP_typeI_n100[2:101,]
round(apply(res_GDP_typeI_n100, 2, mean)/100,3) 

n=1000
set.seed(1)
res_GDP_typeI_n1000=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_GDP_intercell_merge(eps=0.25, size, n, p0, alpha, C),
            typeI_multiple_GDP_intercell_merge(eps=0.5, size, n, p0, alpha, C),
            typeI_multiple_GDP_intercell_merge(eps=0.75, size, n, p0, alpha, C))
  res_GDP_typeI_n1000=rbind(res_GDP_typeI_n1000, typeI_c)
}
res_GDP_typeI_n1000= res_GDP_typeI_n1000[2:101,]
round(apply( res_GDP_typeI_n1000, 2, mean)/100,3) 


#TGDP
p0=c(0.1, 0.1, 0.8)
size=500
alpha=0.05
n=100
C=2
set.seed(1)
res_GDP_typeI_n100_trunc=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_GDP_intercell_merge_trunc(eps=0.25, size, n, p0, alpha, C),
            typeI_multiple_GDP_intercell_merge_trunc(eps=0.5, size, n, p0, alpha, C),
            typeI_multiple_GDP_intercell_merge_trunc(eps=0.75, size, n, p0, alpha, C))
  res_GDP_typeI_n100_trunc=rbind(res_GDP_typeI_n100_trunc, typeI_c)
}
res_GDP_typeI_n100_trunc=res_GDP_typeI_n100_trunc[2:101,]
round(apply(res_GDP_typeI_n100_trunc, 2, mean)/100,3) 


n=1000
set.seed(1)
res_GDP_typeI_n1000_trunc=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_GDP_intercell_merge_trunc(eps=0.25, size, n, p0, alpha, C),
            typeI_multiple_GDP_intercell_merge_trunc(eps=0.5, size, n, p0, alpha, C),
            typeI_multiple_GDP_intercell_merge_trunc(eps=0.75, size, n, p0, alpha, C))
  res_GDP_typeI_n1000_trunc=rbind(res_GDP_typeI_n1000_trunc, typeI_c)
}
res_GDP_typeI_n1000_trunc= res_GDP_typeI_n1000_trunc[2:101,]
round(apply( res_GDP_typeI_n1000_trunc, 2, mean)/100,3) 





#Opt mechanism
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=100
p=rep(1/(n+1), n+1)
merge_idx=list(c(1,2), c(3))
opt_mat1=perturbation_matrix(n, eps=0.25, p)
opt_mat2=perturbation_matrix(n, eps=0.5, p)
opt_mat3=perturbation_matrix(n, eps=0.75, p)
res_opt_typeI_n100=c(1,1,1)
set.seed(1)
for (i in 1:100){
  typeI_c=c(typeI_opt_intercellmerge_manycell(opt_mat1, eps=0.25, size, n, p0, alpha, merge_idx),
            typeI_opt_intercellmerge_manycell(opt_mat2, eps=0.5, size, n, p0, alpha,  merge_idx),
            typeI_opt_intercellmerge_manycell(opt_mat3, eps=0.75, size, n, p0, alpha,  merge_idx))
  res_opt_typeI_n100=rbind(res_opt_typeI_n100, typeI_c)
}
res_opt_typeI_n100=res_opt_typeI_n100[2:101,]
round(apply(res_opt_typeI_n100, 2, mean)/100,3) 



n=1000
p=rep(1/(n+1), n+1)
opt_mat1=perturbation_matrix(n, eps=0.25, p)
opt_mat2=perturbation_matrix(n, eps=0.5, p)
opt_mat3=perturbation_matrix(n, eps=0.75, p)
set.seed(1)
merge_idx=list(c(1,2), c(3))
res_opt_typeI_n1000=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_opt_intercellmerge_manycell(opt_mat1,eps=0.25, size, n, p0, alpha, merge_idx),
            typeI_opt_intercellmerge_manycell(opt_mat2, eps=0.5, size, n, p0, alpha, merge_idx),
            typeI_opt_intercellmerge_manycell(opt_mat3, eps=0.75, size, n, p0, alpha, merge_idx))
  res_opt_typeI_n1000=rbind(res_opt_typeI_n1000, typeI_c)
}
res_opt_typeI_n1000=res_opt_typeI_n1000[2:101,]
round(apply(res_opt_typeI_n1000, 2, mean)/100,3)


#Lap
p0=c(0.1, 0.1, 0.8)
size=500
alpha=0.05
n=100
merge_idx=list(c(1,2), c(3))
set.seed(1)
res_lap_typeI_n100=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_lap_intercell_merge(eps=0.25, size, n, p0, alpha, merge_idx),
            typeI_multiple_lap_intercell_merge(eps=0.5, size, n, p0, alpha, merge_idx),
            typeI_multiple_lap_intercell_merge(eps=0.75, size, n, p0, alpha, merge_idx))
  res_lap_typeI_n100=rbind(res_lap_typeI_n100, typeI_c)
}
res_lap_typeI_n100=res_lap_typeI_n100[2:101,]
round(apply(res_lap_typeI_n100, 2, mean)/100,3) 


n=1000
set.seed(1)
res_lap_typeI_n1000=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_lap_intercell_merge(eps=0.25, size, n, p0, alpha, merge_idx),
            typeI_multiple_lap_intercell_merge(eps=0.5, size, n, p0, alpha, merge_idx),
            typeI_multiple_lap_intercell_merge(eps=0.75, size, n, p0, alpha, merge_idx))
  res_lap_typeI_n1000=rbind(res_lap_typeI_n1000, typeI_c)
}
res_lap_typeI_n1000=res_lap_typeI_n1000[2:101,]
round(apply(res_lap_typeI_n1000, 2, mean)/100,3) 





#TLap
p0=c(0.1, 0.1, 0.8)
size=500
alpha=0.05
n=100
C=list(1:2,3)
set.seed(1)
res_lap_typeI_n100_trunc=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_lap_intercell_merge_trunc(eps=0.25, size, n, p0, alpha, C),
            typeI_multiple_lap_intercell_merge_trunc(eps=0.5, size, n, p0, alpha, C),
            typeI_multiple_lap_intercell_merge_trunc(eps=0.75, size, n, p0, alpha, C))
  res_lap_typeI_n100_trunc=rbind(res_lap_typeI_n100_trunc, typeI_c)
}
res_lap_typeI_n100_trunc=res_lap_typeI_n100_trunc[2:101,]
round(apply(res_lap_typeI_n100_trunc, 2, mean)/100,3) 


n=1000
set.seed(1)
res_lap_typeI_n1000_trunc=c(1,1,1)
for (i in 1:100){
  typeI_c=c(typeI_multiple_lap_intercell_merge_trunc(eps=0.25, size, n, p0, alpha, C),
            typeI_multiple_lap_intercell_merge_trunc(eps=0.5, size, n, p0, alpha, C),
            typeI_multiple_lap_intercell_merge_trunc(eps=0.75, size, n, p0, alpha, C))
  res_lap_typeI_n1000_trunc=rbind(res_lap_typeI_n1000_trunc, typeI_c)
}
res_lap_typeI_n1000_trunc=res_lap_typeI_n1000_trunc[2:101,]
round(apply(res_lap_typeI_n1000_trunc, 2, mean)/100,3)




#####Now we explore the empirical powers by merging the first two cells###

##Lap
#eps=0.25, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
C=list(1:2,3)
n=100
p_v=seq(0.1, 0.25, 0.01)
eps=0.25
set.seed(2)
p_n100_eps0.25_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.25_lap=c(p_n100_eps0.25_lap, pow)
}

#eps=0.5, n=100
p0=c(0.1,0.1,0.8)
eps=0.5
set.seed(1)
p_n100_eps0.5_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.5_lap=c(p_n100_eps0.5_lap, pow)
}

#eps=0.75, n=100
eps=0.75
set.seed(1)
p_n100_eps0.75_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.75_lap=c(p_n100_eps0.75_lap, pow)
}

#eps=0.25, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=1000
p_v=seq(0.1, 0.135, 0.0025)
eps=0.25
set.seed(2)
p_n1000_eps0.25_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.25_lap=c(p_n1000_eps0.25_lap, pow)
}

#eps=0.5, n=1000
eps=0.5
set.seed(2)
p_n1000_eps0.5_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.5_lap=c(p_n1000_eps0.5_lap, pow)
}


#eps=0.75, n=1000
eps=0.75
set.seed(2)
p_n1000_eps0.75_lap=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.75_lap=c(p_n1000_eps0.75_lap, pow)
}




#TLap
#eps=0.25, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
C=list(1:2,3)
n=100
p_v=seq(0.1, 0.25, 0.01)
eps=0.25
set.seed(2)
p_n100_eps0.25_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.25_lap_trunc=c(p_n100_eps0.25_lap_trunc, pow)
}

#eps=0.5, n=100
p0=c(0.1,0.1,0.8)
eps=0.5
set.seed(1)
p_n100_eps0.5_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.5_lap_trunc=c(p_n100_eps0.5_lap_trunc, pow)
}

#eps=0.75, n=100
eps=0.75
set.seed(1)
p_n100_eps0.75_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.75_lap_trunc=c(p_n100_eps0.75_lap_trunc, pow)
}

#eps=0.25, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=1000
p_v=seq(0.1, 0.135, 0.0025)
eps=0.25
set.seed(2)
p_n1000_eps0.25_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.25_lap_trunc=c(p_n1000_eps0.25_lap_trunc, pow)
}

#eps=0.5, n=1000
eps=0.5
set.seed(2)
p_n1000_eps0.5_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.5_lap_trunc=c(p_n1000_eps0.5_lap_trunc, pow)
}


#eps=0.75, n=1000
eps=0.75
set.seed(2)
p_n1000_eps0.75_lap_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_lap_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.75_lap_trunc=c(p_n1000_eps0.75_lap_trunc, pow)
}




#GDP
#eps=0.25, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
C=2
n=100
p_v=seq(0.1, 0.25, 0.01)
eps=0.25
set.seed(1)
p_n100_eps0.25_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.25_GDP=c(p_n100_eps0.25_GDP, pow)
}

#eps=0.5, n=100
p0=c(0.1,0.1,0.8)
eps=0.5
set.seed(1)
p_n100_eps0.5_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.5_GDP=c(p_n100_eps0.5_GDP, pow)
}

#eps=0.75, n=100
eps=0.75
set.seed(1)
p_n100_eps0.75_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.75_GDP=c(p_n100_eps0.75_GDP, pow)
}

#eps=0.25, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=1000
p_v=seq(0.1, 0.135, 0.0025)
eps=0.25
set.seed(1)
p_n1000_eps0.25_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.25_GDP=c(p_n1000_eps0.25_GDP, pow)
}

#eps=0.5, n=1000
eps=0.5
set.seed(1)
p_n1000_eps0.5_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.5_GDP=c(p_n1000_eps0.5_GDP, pow)
}


#eps=0.75, n=1000
eps=0.75
set.seed(1)
p_n1000_eps0.75_GDP=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.75_GDP=c(p_n1000_eps0.75_GDP, pow)
}




#TGDP
#eps=0.25, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
C=2
n=100
p_v=seq(0.1, 0.25, 0.01)
eps=0.25
set.seed(1)
p_n100_eps0.25_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.25_GDP_trunc=c(p_n100_eps0.25_GDP_trunc, pow)
}

#eps=0.5, n=100
p0=c(0.1,0.1,0.8)
eps=0.5
set.seed(1)
p_n100_eps0.5_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.5_GDP_trunc=c(p_n100_eps0.5_GDP_trunc, pow)
}

#eps=0.75, n=100
eps=0.75
set.seed(1)
p_n100_eps0.75_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.75_GDP_trunc=c(p_n100_eps0.75_GDP_trunc, pow)
}

#eps=0.25, n=1000
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=1000
p_v=seq(0.1, 0.135, 0.0025)
eps=0.25
set.seed(1)
p_n1000_eps0.25_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.25_GDP_trunc=c(p_n1000_eps0.25_GDP_trunc, pow)
}

#eps=0.5, n=1000
eps=0.5
set.seed(1)
p_n1000_eps0.5_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.5_GDP_trunc=c(p_n1000_eps0.5_GDP_trunc, pow)
}


#eps=0.75, n=1000
eps=0.75
set.seed(1)
p_n1000_eps0.75_GDP_trunc=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_multiple_GDP_intercell_merge_trunc(eps, size, n, p0, alpha, p1, C)
  p_n1000_eps0.75_GDP_trunc=c(p_n1000_eps0.75_GDP_trunc, pow)
}






#Opt mechanism
#eps=0.25, n=100
p0=c(0.1,0.1,0.8)
size=500
alpha=0.05
n=100
C=list(1:2,3)
pr=rep(1/(n+1), n+1)
p_v=seq(0.1, 0.25, 0.01)
eps=0.25
opt_mat=perturbation_matrix(n, eps, pr)
set.seed(1)
p_n100_eps0.25_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_opt_intercellmerge_manycell(opt_mat,eps, size, n, p0, alpha, p1, C)
  p_n100_eps0.25_opt_c=c(p_n100_eps0.25_opt_c, pow)
}

#eps=0.5, n=100
eps=0.5
opt_mat=perturbation_matrix(n, eps, pr)
set.seed(1)
p_n100_eps0.5_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_opt_intercellmerge_manycell(opt_mat,eps, size, n, p0, alpha,  p1, C)
  p_n100_eps0.5_opt_c=c(p_n100_eps0.5_opt_c, pow)
}

#eps=0.75, n=100
eps=0.75
opt_mat=perturbation_matrix(n, eps, pr)
set.seed(1)
p_n100_eps0.75_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_opt_intercellmerge_manycell(opt_mat,eps, size, n, p0, alpha,  p1, C)
  p_n100_eps0.75_opt_c=c(p_n100_eps0.75_opt_c, pow)
}


#eps=0.25, n=1000
n=1000
pr=rep(1/(n+1), n+1)
eps=0.25
opt_mat=perturbation_matrix(n, eps, pr)
p_n1000_eps0.25_opt_c=c()
p_v=seq(0.1, 0.135, 0.0025)
set.seed(1)
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_opt_intercellmerge_manycell(opt_mat,eps, size, n, p0, alpha,  p1, C)
  p_n1000_eps0.25_opt_c=c(p_n1000_eps0.25_opt_c, pow)
}

#eps=0.5, n=1000
eps=0.5
opt_mat=perturbation_matrix(n, eps, pr)
set.seed(1)
p_n1000_eps0.5_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_opt_intercellmerge_manycell(opt_mat,eps, size, n, p0, alpha,  p1, C)
  p_n1000_eps0.5_opt_c=c(p_n1000_eps0.5_opt_c, pow)
}

#eps=0.75, n=1000
eps=0.75
opt_mat=perturbation_matrix(n, eps, pr)
set.seed(1)
p_n1000_eps0.75_opt_c=c()
for (p in p_v){
  p1=c(p, p, 1-2*p)
  pow=pow_opt_intercellmerge_manycell(opt_mat,eps, size, n, p0, alpha,  p1, C)
  p_n1000_eps0.75_opt_c=c(p_n1000_eps0.75_opt_c, pow)
}







pdf("power_n100_intercell_merge_manycells_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
p_v=seq(0.1, 0.25, 0.01)
plot(p_v, p_n100_eps0.25_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.25', lty=1, col='blue')
points(p_v,  p_n100_eps0.25_lap/100, col="red", pch="*")
lines(p_v, p_n100_eps0.25_lap/100, col="red",lty=2)
points(p_v,  p_n100_eps0.25_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n100_eps0.25_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n100_eps0.25_GDP/100, col="black",pch="+")
lines(p_v,  p_n100_eps0.25_GDP/100, col="black", lty=3)
points(p_v,  p_n100_eps0.25_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n100_eps0.25_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)

plot(p_v, p_n100_eps0.5_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.5', lty=1, col='blue')
points(p_v,  p_n100_eps0.5_lap/100, col="red", pch="*")
lines(p_v, p_n100_eps0.5_lap/100, col="red",lty=2)
points(p_v,  p_n100_eps0.5_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n100_eps0.5_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n100_eps0.5_GDP/100, col="black",pch="+")
lines(p_v,  p_n100_eps0.5_GDP/100, col="black", lty=3)
points(p_v,  p_n100_eps0.5_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n100_eps0.5_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)



plot(p_v, p_n100_eps0.75_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.75', lty=1, col='blue')
points(p_v,  p_n100_eps0.75_lap/100, col="red", pch="*")
lines(p_v, p_n100_eps0.75_lap/100, col="red",lty=2)
points(p_v,  p_n100_eps0.75_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n100_eps0.75_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n100_eps0.75_GDP/100, col="black",pch="+")
lines(p_v,  p_n100_eps0.75_GDP/100, col="black", lty=3)
points(p_v,  p_n100_eps0.75_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n100_eps0.75_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)


dev.off()


pdf("power_n1000_intercell_merge_manycells_new.pdf", width=12, height=4)
par(mfrow=c(1,3),cex=0.7, mai=c(0.6,0.25,0.2,0.2))
p_v=seq(0.1, 0.135, 0.0025)
plot(p_v, p_n1000_eps0.25_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.25', lty=1, col='blue')
points(p_v,  p_n1000_eps0.25_lap/100, col="red", pch="*")
lines(p_v, p_n1000_eps0.25_lap/100, col="red",lty=2)
points(p_v,  p_n1000_eps0.25_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n1000_eps0.25_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n1000_eps0.25_GDP/100, col="black",pch="+")
lines(p_v,  p_n1000_eps0.25_GDP/100, col="black", lty=3)
points(p_v,  p_n1000_eps0.25_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n1000_eps0.25_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)

plot(p_v, p_n1000_eps0.5_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.5', lty=1, col='blue')
points(p_v,  p_n1000_eps0.5_lap/100, col="red", pch="*")
lines(p_v, p_n1000_eps0.5_lap/100, col="red",lty=2)
points(p_v,  p_n1000_eps0.5_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n1000_eps0.5_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n1000_eps0.5_GDP/100, col="black",pch="+")
lines(p_v,  p_n1000_eps0.5_GDP/100, col="black", lty=3)
points(p_v,  p_n1000_eps0.5_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n1000_eps0.5_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)



plot(p_v, p_n1000_eps0.75_opt_c/100, type='o', ylim=c(0,1),
     xlab='Alternative Hypothesis (p1)', ylab='Empirical power', pch='o',
     main = 'Epsilon=0.75', lty=1, col='blue')
points(p_v,  p_n1000_eps0.75_lap/100, col="red", pch="*")
lines(p_v, p_n1000_eps0.75_lap/100, col="red",lty=2)
points(p_v,  p_n1000_eps0.75_lap_trunc/100, col="darkgoldenrod1",pch=16)
lines(p_v,  p_n1000_eps0.75_lap_trunc/100, col="darkgoldenrod1", lty=5)
points(p_v,  p_n1000_eps0.75_GDP/100, col="black",pch="+")
lines(p_v,  p_n1000_eps0.75_GDP/100, col="black", lty=3)
points(p_v,  p_n1000_eps0.75_GDP_trunc/100, col="purple",pch=5)
lines(p_v,  p_n1000_eps0.75_GDP_trunc/100, col="purple", lty=4)

legend(0.1,1,legend=c("Opt","Lap","TLap","GDP","TGDP"), col=c("blue","red","darkgoldenrod1","black","purple"),
       pch=c("o","*",16, "+",5),lty=c(1,2,5, 3,4), ncol=1,cex=0.75)

dev.off()





















































